class Grading:
    def __init__(self, df, subject,g):
        self.__score_df = df
        self.__subject = subject
        self.__tscorelist = []
        self.__gradenum= g
        self.__grade = []
    @property
    def grade(self):
        return self.__grade
    @grade.setter
    def grade(self,g):
        self.__grade = g

    @property
    def subject(self):
        return self.__subject
    @subject.setter
    def subject(self, s):
        self.__subject = s

    @property
    def gradenum(self):
        return self.__gradenum


    def tscore_cal(self,mean,sd):
        scorelist = self.__score_df[self.__subject]
        zscorelist = []
        for i in scorelist:
            zscore = (i-mean)/sd
            zscorelist.append(zscore)
        for i in zscorelist:
            tscore = (i*10)+50
            self.__tscorelist.append(tscore)


    def grade_cal(self,type,fullscore):
        if type == "Relative grading":
            score = self.__tscorelist
            fullscore = 100
        else:
            score = self.__score_df[self.__subject]

        for j in score:
            i = (j/fullscore)*100
            if i >= self.__gradenum[0]:
                self.__grade.append("A")
            elif self.__gradenum[0] > i >= self.__gradenum[1]:
                self.__grade.append("B+")
            elif self.__gradenum[1] > i >= self.__gradenum[2]:
                self.__grade.append("B")
            elif self.__gradenum[2] > i >= self.__gradenum[3]:
                self.__grade.append("C+")
            elif self.__gradenum[3] > i >= self.__gradenum[4]:
                self.__grade.append("C")
            elif self.__gradenum[4] > i >= self.__gradenum[5]:
                self.__grade.append("D+")
            elif self.__gradenum[5] > i >= self.__gradenum[6]:
                self.__grade.append("D")
            else:
                self.__grade.append("F")




