class Graph:
    def __init__(self,df):
        self.df = df
        self.grade = ['A','B+','B','C+','C','D+','D','F']

    def setGradefrequency(self,subject):
        observelist = []
        g = self.df[subject].tolist()
        for i in self.grade:
            observe = []
            for j in g:
                if i == j:
                    observe.append(i)
            observelist.append(observe)
        observe_num = []
        for i in observelist:
            observe_num.append(len(i))
        y = observe_num
        return y

    def setScorefrequency(self,score_list):
        xlist = []
        observelist = []

        for i in score_list:
            if i not in xlist:
                xlist.append(i)
            observelist.append(i)



    def recievedcols(self,boolist,collist):
        new_collist = []
        for i in range(len(boolist)):
            if boolist[i].get() == "1":
                new_collist.append(collist[i])
        return new_collist



    def bargraph(self,ax,cv,datalist,collist):
        ax.clear()
        # set y axis
        ylist = []
        g = self.recievedcols(datalist,collist)
        for i in range(len(g)):
            y = self.setGradefrequency(g[i])
            ylist.append(y)

        # set coordinate of bar graph
        n = len(g)
        n1 = (-0.2)*n
        nlist = []
        if n % 2 == 0 :
            for i in range(n):
                n1 = n1 + 0.2
                if n1 != 0 :
                    nlist.append(n1)
                else:
                    n1 = n1 + 0.2
                    nlist.append(n1)
        else:
            for i in range(n):
                n1 = n1 + 0.2
                nlist.append(n1)
        # set position of each bar
        position = [1,2,3,4,5,6,7,8]
        for i in range(n):
            new_pos = []
            for j in position:
                new_pos.append(j+nlist[i])
            ax.bar(new_pos , ylist[i],width=0.2,label=g[i])
        text = g[0]
        for i in range(len(g)-1) :
            text = text + " and " + g[i+1]
        ax.set_title("grade of "+text )
        ax.set_xticks(position)
        ax.set_xticklabels(self.grade)
        ax.legend(fontsize=7)
        for item in ([ax.title, ax.xaxis.label, ax.yaxis.label] + ax.get_xticklabels() + ax.get_yticklabels()):
            item.set_fontsize(7)
        cv.draw()

    def linegraph(self,ax,cv,datalist,collist,type):
        ax.clear()
        if type == "grade":
            # set y axis
            ylist = []
            g = self.recievedcols(datalist, collist)
            for i in range(len(g)):
                y = self.setGradefrequency(g[i])
                ylist.append(y)
            x = self.grade
            n = len(g)
            for i in range(n):
                ax.plot(x, ylist[i], label=g[i])
        else:
            ylist = []
            g = self.recievedcols(datalist, collist)
            xlist = []
            for i in g:
                x = self.df[i].value_counts().values.tolist()
                y = self.df[i].value_counts().index.tolist()
                ylist.append(y)
                xlist.append(x)
            n = len(g)
            for i in range(n):
                ax.plot(xlist[i], ylist[i], label=g[i])
            ax.set_xlabel("frequency")
            ax.set_ylabel("score")
        ax.legend(fontsize=7)
        for item in ([ax.title, ax.xaxis.label, ax.yaxis.label] + ax.get_xticklabels() + ax.get_yticklabels()):
            item.set_fontsize(7)
        cv.draw()



    def histgraph(self, ax, cv, datalist, collist, type,  grade,fullscore):
        ax.clear()
        if type == "grade":
            g = self.recievedcols(datalist, collist)
            f = self.recievedcols(datalist, fullscore)
            xcol = []
            n = len(g)
            # delete 'grade' word in collist
            for i in collist:
                j = i.split()
                text = ''
                for k in j:
                    if k == "grade":
                        j.remove(k)
                for l in range(len(j)):
                    if l == len(j)-1:
                        text = text+j[l]
                    else:
                        text = text+j[l]+" "

                if i == "grade":
                    text = 'total score'
                xcol.append(text)
            # set grade
            gradelist = []
            for k in f:
                gradenum = []
                for j in grade:
                    i = (k/100) * j
                    gradenum.append(round(i))
                grade_labels = {gradenum[0]: 'A',gradenum[1]: 'B+',gradenum[2]: 'B',gradenum[3]: 'C+',gradenum[4]: 'C',gradenum[5]: 'D+',gradenum[6]:'D'}
                gradelist.append(grade_labels)

            print(xcol)
            for i in range(n):
                if n == 1:
                    ax.hist(self.df[xcol[i]], label=g[i])
                else:
                    ax.hist(self.df[xcol[i]], alpha=0.5, label=g[i])
                ax.set_xticks(list(gradelist[i].keys()))
                ax.set_xticklabels(list(gradelist[i].values()))
            ax.set_title('Histogram of grade')

        else:
            g = self.recievedcols(datalist, collist)
            xlist = []
            for i in g:
                xlist.append(self.df[i].tolist())
            n = len(g)
            for i in range(n):
                if n == 1:
                    ax.hist(xlist[i], label=g[i])
                else:
                    ax.hist(xlist[i], alpha=0.5, label=g[i])
            ax.set_title('Histogram of score')
        ax.legend(fontsize=7)
        for item in ([ax.title, ax.xaxis.label, ax.yaxis.label] + ax.get_xticklabels() + ax.get_yticklabels()):
            item.set_fontsize(7)
        cv.draw()

    def scattergraph(self,ax,cv,x,y):
        ax.clear()
        ax.scatter(self.df[x],self.df[y],alpha=0.5)
        ax.set_xlabel(x)
        ax.set_ylabel(y)
        ax.set_title('Scatter plot of '+x+" and "+ y)
        for item in ([ax.title, ax.xaxis.label, ax.yaxis.label] + ax.get_xticklabels() + ax.get_yticklabels()):
            item.set_fontsize(7)

        cv.draw()
