import pandas as pd
class CsvRead:
    def __init__(self,filename):
        # read csv file as dataframe
        self.df = pd.read_csv(filename)
        self.__subjectName = []

    @property
    def subjectName(self):
        return self.__subjectName

    def getSubjectName(self):
        column = list(self.df)
        # delete name and ID to find all subject
        if "Name" in column:
            column.remove("Name")
        if "ID" in column:
            column.remove("ID")
        for i in column:
            if "grade" in i.lower():
                column.remove(i)
        self.__subjectName = column

    def getGradelist(self):
        column = list(self.df)
        gradelist = []
        for i in column:
            if "grade" in i:
                gradelist.append(i)
        return gradelist


    def addSumData(self):
        sum = 0
        for i in self.subjectName:
            sum = self.df[i] + sum
        self.df["total score"] = sum
        # self.df["total score"] = sum(self.df[self.getSubjectName()])





