class Statistic:
    def __init__(self, df, data):
        self.__score_dataframe = df
        self.__data = data
        self.__average = 0
        self.__sd = 0
        self.__min = 0
        self.__max = 0
        self.__total = 0

    @property
    def average(self):
        return self.__average
    @property
    def sd(self):
        return self.__sd
    @property
    def min(self):
        return self.__min
    @property
    def max(self):
        return self.__max
    @property
    def total(self):
        return self.__total
    @property
    def data(self):
        return self.__data
    @data.setter
    def data(self, data):
        self.__data = data

    def cal_average(self):
        self.__average = self.__score_dataframe[self.__data].mean()

    def cal_sd(self):
        self.__sd = self.__score_dataframe[self.__data].std()

    def cal_min(self):
        self.__min = self.__score_dataframe[self.__data].min()

    def cal_max(self):
        self.__max = self.__score_dataframe[self.__data].max()

    def cal_total(self):
        self.__total = (self.__score_dataframe.shape)[0]




